// Modules.h: Module function declaration
//

inline double frand1 ();

inline double frand2 ();

inline double frand3 ();

inline double frand4 ();

inline void CosDistr (double &angle1, double &angle2);

inline void CosDistr2 (double &angle1, double &angle2);

inline void UniDistrFull (double &angle1, double &angle2);

inline void UniDistrHalf (double &angle1, double &angle2);

double degree2rad (double angle_degree);

inline double rad2degree (double angle_rad);

void mInit (valarray< valarray< valarray<int> > > &m, int mSize_x, int mSize_y);

void Pause ();

void MolInit (valarray<double> &pos, valarray<double> &Dir, double &path_tot, 
			  double &path, double MFP_mean, double &MFP);

void MolTube (valarray<double> &pos, valarray<double> &Dir, valarray<double> &Dir_new, 
			  double &path_tot, double &path);

void MFP_adapt(double &MFP, double MFP_mean, double &path, 
			   valarray<double> &pos, valarray<double> &pos_old, double virtual_pos[], int virtual_no,
			   double MFPsampling[], double MFPsectionCount[], valarray<double> &dir,
			   double planecenter, double planetilt, double DeltaP);

bool MolMol (valarray<double> &pos, valarray<double> &Dir, valarray<double> &Dir_new, 
			 double &path_tot, double &path, double MFP_mean, double &MFP,
			 double planecenter);

bool MolMol_pressure_decay (valarray<double> &pos, valarray<double> &Dir, valarray<double> &Dir_new, 
			 double &path_tot, double &path, double MFP_mean, double &MFP,
			 double planecenter, double DeltaP);

bool MolTransTubeEnd (valarray<double> &pos, valarray<double> &Dir, 
					  double &path_tot, double planecenter, 
					  double planetilt);

bool MolTransHole (valarray<double> &pos, double z_hole, 
				   double tilt_hole, double r_hole, double TC_hole);

bool MolBack (valarray<double> &pos, valarray<double> &dir);

bool MolUptake (double uptakecoeff);

void ReferenceSystemChange (valarray<double> &pos, valarray<double> &dir, double &angle1, double &angle2, double dist, 
					   double planecenter, double planetilt);

bool SubstrateStrike (valarray<double> &pos, valarray<double> &dir, 
					  valarray<double> &pos_substrate, 
					  valarray<double> &dir_substrate, 
					  double &pathtot, double &angle1, double &angle2, double dist,
					  double planecenter, double planetilt);

void MolPressure (valarray<double> &pos, valarray<double> &pos_old, 
				  double virtual_pos[], int virtual_no, double TRflux[], double BSflux[]);

void Desorption_Back (valarray<double> &pos_sub, valarray<double> &DB, double &angle1, double &angle2, 
					  double dist, double planecenter, double planetilt, 
					  int &index);
